#include "mbed.h"
#include "core.h"
/*the class  AdcFilter process a analog value (float)  and apply a  a filter
   1. filter big spikes  ( greater than delta)
	 2. filter random precision errors ( exponential smoothing
*/

AdcFilter::AdcFilter() {
    y=0;
    init=false;
    //default values for a agressive filter
    delta=0.5;  // the value abs(x)<1  -> delta= 5% of the full value
    smooth= 0.10;
}
float AdcFilter::filter(float x) {
    if (!init) { //first sample
        y=x; //accept the sample
        init=true;
        return y;
    }
    //clear the spikes

    if (x > y+delta)
        x= y+delta;
    if (x < y-delta)
        x= y-delta;
    //smooth the high frequecy small errors (exponential smoothing)
    y = x*smooth + (1-smooth)*y;
    return y;
}
