#include "core.h"
bool get_code_operation(code_operation& c, string name) {
	c.statevar=false; /*normal value
     - a statevar is a normal variable which is NOT resetted before each loop
     -the initial value after program load is zero
     -available to any operation
     */
	c.outvar=false; // o//------------------------------------------------without  outvar --------------------------------------------------------//
	c.intvar=0 ; /*internal variables for an operation variables
     - this is not a variable in the vector of variables
     - this is a numerical constant in the operation vector, after the parameters
     - only available within one operation line
    */
	if(name=="IF") {
		c.codeop=OP_IF;
		return true;
	}
	if(name=="IFNOT") {
		c.codeop=OP_IFNOT;
		return true;
	}
	if(name=="ENDIF") {
		c.codeop=OP_ENDIF;
		return true;
	}
	if(name=="DTRIM1") {
		c.codeop=OP_DTRIM1;
		return true;
	}
	if(name=="DTRIM2") {
		c.codeop=OP_DTRIM2;
		return true;
	}
	if(name=="DTRIM3") {
		c.codeop=OP_DTRIM3;
		return true;
	}
	if(name=="DTRIM4") {
		c.codeop=OP_DTRIM4;
		return true;
	}

	if(name=="BEEP") {
		c.codeop=OP_BEEP;
		return true;
	}
	if(name=="BREAK") {
		c.codeop=OP_BREAK; //followed with  string variable(s)
		return true;
	}
	if(name=="JETIRX") {
		c.codeop=OP_JETIRX; //followed with  string variable(s)
		c.intvar=1;
		return true;
	}
	if(name=="SLOW") {
		c.codeop=OP_SLOW;
		return true;
	}
	if(name=="UPD") {
		c.codeop=OP_UPD;
		return true;
	}
	if(name=="MODUL") {
		c.codeop=OP_MODUL;
		return true;
	}
	if(name=="SHOW") {
		c.codeop=OP_SHOW;
		return true;
	}
	if(name=="SHOWT") {
		c.codeop=OP_SHOWT;
		return true;
	}
	if(name=="PLAY") {
		c.codeop=OP_PLAY;
		return true;
	}
	if(name=="PLAYV") {
		c.codeop=OP_PLAYV;
		return true;
	}
	if(name=="PLAYT") {
		c.codeop=OP_PLAYT;
		return true;
	}
	if(name=="PLAYS") {
		c.codeop=OP_PLAYS;
		return true;
	}
	if(name=="JETIX") {
		c.codeop=OP_JETIX;
		return true;
	}
	if(name=="LOG") {
		c.codeop=OP_LOG;
		return true;
	}
	if(name=="HOLD") {
		c.codeop=OP_HOLD;
		return true;
	}


	c.outvar=true;//------------------------------------------------with outvar --------------------------------------------------------//
	c.typenum=NUM; // op codes with outvar= num
	if(name=="ADD") {
		c.codeop=OP_ADD;
		return true;
	}
	if(name=="SUB") {
		c.codeop=OP_SUB;
		return true;
	}
	if(name=="INIT") {
		c.codeop=OP_INIT;
		return true;
	}
	if(name=="MULT") {
		c.codeop=OP_MULT;
		return true;
	}
	if(name=="MULT%") {
		c.codeop=OP_MULT_PC;
		return true;
	}
	if(name=="EQU"|| name=="=") {
		c.codeop=OP_EQU;
		return true;
	}
	if(name=="DELTA") {
		c.codeop=OP_DELTA;
		c.intvar=1;
		return true;
	}
	if(name=="EQU_PARAM") {
		c.codeop=OP_EQU_PARAM;
		return true;
	}
	if(name=="LINE") {
		c.codeop=OP_LINE;
		return true;
	}
	if(name=="CURVE") {
		c.codeop=OP_CURVE;
		return true;
	}
	if(name=="EXP") {
		c.codeop=OP_EXPO;
		return true;
	}

	if(name=="OUT") {
		c.codeop=OP_OUT;
		c.intvar=1; // for the slow phase transition
		return true;
	}
	if(name=="OUTN") {
		c.codeop=OP_OUTN;
		return true;
	}
	if(name=="SERV") {
		c.codeop=OP_SERV;
		return true;
	}
	if(name=="ADDS") {
		c.codeop=OP_ADDS;
		return true;
	}
	if(name=="SUBS") {
		c.codeop=OP_SUBS;
		return true;
	}
	if(name=="ADDAS") {
		c.codeop=OP_ADDAS;
		return true;
	}
	if(name=="SUBAS") {
		c.codeop=OP_SUBAS;
		return true;
	}
	if(name=="NUM") {
		c.codeop=OP_NUM;
		return true;
	}
	if(name=="NUMT") {
		c.codeop=OP_NUMT;
		c.intvar=1;
		c.statevar=true;
		return true;
	}
	if(name=="CHR+") {
		c.codeop=OP_CHRPLUS;
		c.statevar=true;
		return true;
	}
	if(name=="CHR-") {
		c.codeop=OP_CHRMIN;
		c.statevar=true;
		return true;
	}
	if(name=="RAL") {
		c.codeop=OP_RAL;
		c.statevar=true;
		return true;
	}
	if(name=="JETI") {
		c.codeop=OP_JETI;
		c.intvar=3; // ask  last computed variable or unknown  validity in ticks
		return true;
	}
	if(name=="PID") {
		c.codeop=OP_PID;
		c.intvar=4; // sum_error, last process variable, last processed time, last PID correction
		return true;
	}
		if(name=="PIDA") {
		c.codeop=OP_PIDA;
		c.intvar=5; // setup value,sum_error, last provcess variable, last processed time , last PID correction
		return true;
	}
	
	
	c.outvar=true;
	//=============================================================
	c.typenum=LOGICAL; // op codes with outvar= logical
	if(name=="PHASE") {
		c.codeop=OP_PHASE; //!!! here the "outvar" is the condition var
		return true;
	}
	if(name=="AND") {
		c.codeop=OP_AND;
		return true;
	}
	if(name=="OR") {
		c.codeop=OP_OR;
		return true;
	}
	if(name=="NOT") {
		c.codeop=OP_NOT;
		return true;
	}
	if(name=="MEM") {  //!!!!!!!!!!!!!! non test&#65533;- remplacer statevar par variable d'&#65533;tat interne &#65533; l'op&#65533;ration ???
		c.codeop=OP_MEM;
		c.statevar=true;
		return true;
	}
	if(name=="VART") {
		c.codeop=OP_VART;
		c.intvar=1; // former value
		return true;
	}
	if(name=="VARF") {
		c.codeop=OP_VARF;
		c.intvar=1; // 
		return true;
	}
	if(name=="COMP") {
		c.codeop=OP_COMP;
		return true;
	}
	if(name=="COMPA") {
		c.codeop=OP_COMPA;
		c.intvar=1 ; //last signalled value
		return true;
	}
	if(name=="COMPH") {
		c.codeop=OP_COMPH;
		c.statevar=true;
		return true;
	}
	if(name=="FALSE") {
		c.codeop=OP_FALSE;
		return true;
	}
	if(name=="TRUE") {
		c.codeop=OP_TRUE;
		return true;
	}
	if(name=="VAR") {
		c.codeop=OP_VAR;
		c.intvar=1 ; //last signalled value
		return true;
	}

	return false; //unknown
}