#include "core.h"
extern rccl_data rc; //common data
/* digital trims  and debouncer*/
// constructor
Dtrim::Dtrim() {
	timer =0;
	timerSnd=0;
	indexPvarNormalTrim =-1;
	indexPvarTuneParam =-1;
}
void Dtrim::get(int dirp ,int dirm) {
	short dtrim_max  ;

	// identify the parameter
	short param_index;
	if(rc.calcptr->dtrim_level <=1) { //normal trim
		param_index=indexPvarNormalTrim;
		dtrim_max = DTRIM_MAX; // trim limit
	} else { //the trim buttons change a selected parameter (in flight update of 1 to 4 parameters)
		param_index=indexPvarTuneParam;
		dtrim_max = 100; // no limit for a parameter update in flight
	}
	if(param_index <0)
		return;
	//printf ("Dtrim::get level=%i param_index=%i  \n",rc.calcptr->dtrim_level,param_index);
	Var * pvar = rc.calcptr->getVarptr(param_index);
	short vvar_index =  pvar->value -TOVAR;
	//printf ("Dtrim::get vvar_index=%i  \n",vvar_index);
	Var * vvar = rc.calcptr->getVarptr(vvar_index);//PVAR to update vvar->value=value;
	//sound the value when the buttons are released
	if(dirp==0 && dirm==0 && timer > 0) { 
		float valueF ;
		valueF =((float) vvar->value) /TOINT;
		rc.sndptr->putValue(valueF,0);
		rc.sndptr->zput(200);
	}
	if(dirp==0 && dirm==0) {
		timer = 0;//timer measures the duration during which a button is pushed  (unit = 10 msec  )
		return;
	}	
	
	
	
	
	// reset to zero
	if(dirp==1 && dirm==1) {
		timer = 0;
		vvar->value = 0;
		int t = GetTicker();
		//printf("Dtrim reset at %d  dirp=%d  dirm=%d\n",t,dirp, dirm);
		//rc.lcdptr->PinDump();
		if(t > timerSnd +50) {
			rc.sndptr->putFile("2T2");//sound  "reset"
			timerSnd=t;
		}
		return;
	}
	/* speed
	  initial speed 1% /sec
	  after 1 sec, speed 10 % /sec
	  after 2.5 sec , speed 25%/sec) */
	timer ++;
	short tick;
	if(timer < 100)   //<1 sec
		tick=1;  // tck +1 each 10msec = 1% /sec
	else if(timer <250) {
		tick = 10;
	} else {
		tick = 25;
	}
	if(dirm ==1) {
		tick = -tick;
		//vvar->value = valcheck(vvar->value + tick);
		vvar->value = max(vvar->value + tick , -dtrim_max*TOINT);
	} else {
		vvar->value = min(vvar->value + tick , dtrim_max*TOINT);
	}
	
	// sound a  "click" every second
	int t = GetTicker();
	if((t >  timerSnd+100)&& timer >10) {
		rc.sndptr->putFile("2T1");
		timerSnd=t;
	}
	// display pvar name and vvar value on line 6
	rc.calcptr->lcd[5] = pvar->name;
	rc.calcptr->lcd[6] = vvar->valueS(1);
	rc.calcptr->lcd_protect[5]= GetTicker()+100;
	rc.calcptr->lcd_protect[6]= GetTicker()+100;
}
Debounce::Debounce() {
	state=0;
	ticker=0;

}
bool Debounce::get(bool x) {
	/* x = io pin sampled each 10 msec
	Button pushed if x= true
	state 0 = normal, no activity
	state 0->deb  pushing the button , not yet recognized



	*/
	int const deb = 5;
	if(!x && state==0) return false;
	//printf("Debounce state=%d  x=%d\n",state,x);
	if(x && state < 128)  state++;   //contact on
	if(!x && state < 128) state=0;  //reset
	if(state > deb && state < 128) {
		state= 255;
		//printf("Debounce TRUE\n");
		return true;
	}
	if(x && state >128) state =255;
	if(!x && state >128) state --;
	if(state >128 && state <255 - deb) { state = 0; ticker=GetTicker();}
	return false;
}

