/* editor of files like .mdx
cal this editor


- display a view of the file + command line to shift this view in the 4 directions ,select a greater font
- after selection of one line, the command line allows
    - delete line
    - insert blank  before the selected line or add at end
    - edit the line (calls ed1
        move a cursor
        insert characters , delete ...
 */
#include "core.h"
extern rccl_data rc; //common data
// constructor for the editors need only a filename
Ed::Ed(string f, bool ro): modele(f),marge(25) {//--------------edit file f loaded in a Mdx object modele(f)  with the default font----   ro= readonly to check the file at startup
    setfont('\x02');
    selectedline=-1;
	  readonly = ro;
    //printf("Ed constructor %s\n",f.c_str());
}
void Ed::setfont(char f) {
// calculates the number of line/colums... to display the text
    switch (f) {
    case '\x00':
        font_x=5;
        font_y=8;
        font=f;
        break;// !!!error in the documentation; height is 8
    case '\x01':
        font_x=8;
        font_y=8;
        font=f;
        break;
    case '\x03':
        font_x=12;
        font_y=16;
        font=f;
        break; // 15 lignes * 26 col
    default:
        font_x=8;
        font_y=12;
        font='\x02';
        break;
    }
    // the display is 240*320 landcape oriented
    pix_x=LCDX;
    pix_y=LCDY - marge;
    n_x= pix_x/font_x; //available char /line
    n_y= pix_y/ font_y;//available lines
    //printf("Ed setfont n_x=%d font_y=%d n_y=%d marge=%d\n",n_x,font_y,n_y,marge);
}
void Ed::display() {//display the text and select a line
    //printf("ed.display start\n");
    int x=0;
    int y=0; //current position
    int xt,yt;
    int step_y= n_y/2 ,step_x= n_x/3;//pagination step
    //tabs 12pixels/char
    const int ar_back=0,ar_save= 100,ar_plusm=150, ar_u=200, ar_d=240 , ar_l=270, ar_r=300;//tabs on the command line, without selected line
    const int as_del=53 ,as_ip=106 ,as_im=159 ,as_h=212 , as_n=265;
    //printf("Ed lignes =%d n_y=%d  y=%d\n"  ,modele.getnblignes(),n_y,y);

    while (true) { //loop on the display
        //printf("rc.lcdptr %d\n",rc.lcdptr);
        rc.lcdptr->Cls();
        // bottom command line
        rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
        rc.lcdptr->Rectangle(0,LCDY-marge,LCDX,LCDY, getColor(BACKGROUND_CMD));
        int yb=LCDY-marge+5; //upper alignement of font 3
        rc.lcdptr->Textcmd(string("BACK"),ar_back,yb);
		rc.lcdptr->Textcmd(string("COPY"),ar_save,yb);
        if (selectedline<0 || readonly) {//pagination  arrows
            rc.lcdptr->ArrowCmd(ARROW_UP  ,ar_u,yb);
            rc.lcdptr->ArrowCmd(ARROW_DOWN,ar_d,yb);
            rc.lcdptr->ArrowCmd(ARROW_LEFT,ar_l,yb);
            rc.lcdptr->ArrowCmd(ARROW_RIGHT,ar_r,yb);
            rc.lcdptr->Textcmd(string(" +/- "),ar_plusm,yb);
        } else {//commands if a line is selected
            rc.lcdptr->Textcmd(string("EDIT"),as_n,yb);
            rc.lcdptr->Textcmd(string(" ? "),as_h,yb);
            rc.lcdptr->Textcmd(string("INS"),as_im,yb);
            if (selectedline==(modele.getnblignes()-1))//last line is selectec
                rc.lcdptr->Textcmd(string("Add"),as_ip,yb);
            rc.lcdptr->Textcmd(string("DEL"),as_del,yb);
        }
        //display the text

        for (int i =0; (i<n_y)&&(i<modele.getnblignes()-y); i++) {  //&&(i<model.getnblignes()
            string z = modele.getline(i+y);
            char linenr [4];
            if (font=='\x02') {
                sprintf(linenr,"%d",i+y);  // line number from 0 
                z = string(linenr)+" "+z;
            }
            if ((int)z.length() >x) {
                rc.lcdptr->Textg (z.substr(x,n_x),0,i*font_y, font,((i+y==selectedline)?RED: getColor(FOREGROUND_TEXT)),1,1);
                //printf("Ed text =%s\n"  ,z.substr(x,n_x).c_str());
            }
        }
        //printf("ed.display before touch\n");
        rc.lcdptr->GetTouch(  &xt,  &yt);
        //printf("ed.display after touch\n");
        if ( yt>LCDY-marge) { // selection within the command line
            if (selectedline<0 || readonly) {
                if (xt> ar_r) {
                    x=min(MAXLINE-n_x ,x+step_x);     //shift right
                    continue;
                }
                if (xt> ar_l) {
                    x=max(0,x-step_x);    //shift left
                    continue;
                }
                if (xt> ar_d) {
                    y=min(modele.getnblignes()-n_y+2,y+step_y);
                    continue;
                }
                if (xt> ar_u) {
                    y=max(0,y-step_y);
                    continue;
                }
                if (xt> ar_plusm ) {
                    setfont( (font=='\x02'?'\x03':'\x02'));    //change the font size
                    continue;
                }
				//======= quit =========
				if (xt> ar_save ) {
                    saveAs(); 
                    return;
                }
                rc.lcdptr->Cls();
				if (!readonly)
					modele.save();
                return; //back !!!!!
            } else { //commands when a line is selected and not readonly
                if (xt> as_n) {
                    displayLine(); //EDIT
                    continue;
                }
                if (xt > as_h) { //// ?
                    displayHelp();
                    selectedline=-1;
                    continue;
                }
                if (xt> as_im) {
                    vector<string>::iterator it =modele.lignes.begin()+selectedline ;
                    modele.lignes.insert(it,"#.....");
                    selectedline=-1;
                    continue;
                }
                if (xt> as_ip && selectedline==modele.getnblignes()-1 ) { //add at the end of the file
                    modele.lignes.push_back("#.....");
                    selectedline=-1;
                    continue;
                }
                if (xt> as_del) {
                    vector<string>::iterator it =modele.lignes.begin()+selectedline ;
                    modele.lignes.erase(it);
                    selectedline=-1;
                    continue;
                }

                //back
                selectedline=-1;
                continue;
            }
        }
        //selection in the text zone above the command line
				if (!readonly)
					selectedline=(yt/font_y)+y;
        continue;
    }
}
void Ed::displayHelp() {/* give info over a selected line
    1) CALL xxx -> display the file xxx
    2) other    -> display a help file over the op code */
    vector<string> tokens;
    tokens = modele.gettokens(modele.getline(selectedline));
	if (tokens.size() ==0)
		return;
    if (tokens[0]=="CALL") { // display the called file
        Ed ed(string(tokens[1].c_str())+".mdm",false);
        ed.display();
        return;
    }
}
void Ed::displayLine() {//display the line  "selectedline"
    string ligne = modele.getline(selectedline);
    //line display status
    int cursor  =0 ;//position of the cursor (text is insered before the cursor)
    bool upper   =false ;// 0= lower case 1 = uppercase
    bool kbpaint = true; //0 = no repaint is needed
    // vertical coordinates
    const char kba[]= "abcdefghijklmnopqrstuvwxyz"; // display font width= 24 heigth=32 
    const char kbA[]= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    const char kb3[]= "0123456789+- .:#=@_\"!?%&$";
    const int  yc2=215; // command line heighth=25
    const int  y3=148; // two lines with kb3 h=32*2
    const int  ya=84; // two lines with kba or kbA h=32*2
    const int  xc11=0, xc12=60,xc13=120,xc14=180;
    rc.lcdptr->Cls();
    // text zone for  4 text lines font 12*16 max 25 char/line
    rc.lcdptr->Pen('\x01');
    rc.lcdptr->Rectangle(2,2,318,71, getColor(FOREGROUND_TEXT));
    rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
    //paint the permanent lines
    // bottom command line
    rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
    rc.lcdptr->Rectangle(0,pix_y,LCDX,LCDY, getColor(BACKGROUND_CMD));
    int yb=LCDY-marge+5; //upper alignement of font 3
    rc.lcdptr->Textcmd(string("BACK"),xc11,yb);
    rc.lcdptr->Textcmd(string(" Aa "),xc12,yb);
    rc.lcdptr->Textcmd(string("<Del"),xc13,yb);
    rc.lcdptr->Textcmd(string("Del "),xc14,yb);
    while (1) {//process each touch
        int xt,yt;//touch coordinates
        //paint the text
        rc.lcdptr->Rectangle(0,0,LCDX,font_y*4, getColor(BACKGROUND_TEXT)); //erase the text and the cursor !
        for (int i=0; i*25<(int)ligne.size(); i++)
            rc.lcdptr->Textg(ligne.substr(i*25,25),5,5+(i*16),'\03',getColor(FOREGROUND_TEXT),1,1);//font 12*16, repaint the text

        // cursor
        int yc= cursor/25;
        int xc= cursor-(yc*25);
        rc.lcdptr->Textg("_",5+(xc*12),5+(yc*16),'\03',RED,1,1);//font 12*16
        //repaint the keyboard
        if (kbpaint) {
            rc.lcdptr->Rectangle(0,ya,LCDX,ya+(32*4), getColor(BACKGROUND_CMD));
            rc.lcdptr->Textg((upper ? kbA:kba),0,ya,'\03',getColor(FOREGROUND_CMD),2,2);//2lines
            rc.lcdptr->Textg(kb3,0,y3,'\03',getColor(FOREGROUND_CMD),2,2);// show
            kbpaint=false;
        }
        rc.lcdptr->GetTouch(  &xt,  &yt);
        if ( yt > yc2) {//touch within the command line
            if (xt>xc14) { // delete the char right
                if ((int)ligne.size()>cursor)
                    ligne.erase(cursor,1);
                continue;
            }
            if (xt>xc13) { // delete left
                if (cursor>0) {
                    cursor--;
                    ligne.erase(cursor,1);
                }
                continue;
            }
            if (xt>xc12) {
                kbpaint=true;    // uppercase/lowercase
                upper=(upper? false:true);
                continue;
            }
            break;////back !!!!!!!!!!!!!! update model prevoir un cancel
        }
        if (yt>ya) { //touch the keyboard char entry
            int y= (yt-ya)/32; //row
            int x= xt/24;      //column
            char z='?';
            if (y==0)        z=(upper ? kbA[x]:kba[x]);
            else if (y==1)  z=(upper ? kbA[x+13]:kba[x+13]);
            else if (y==2)  z=kb3[x];
            else            z=kb3[x+13];
            //printf("kb ligne=%d col=%d  char=%c\n",y,x,z);
            ligne.insert(cursor,1,z);//insert this char at the cursor position
            cursor++;
            continue;
        }
        //other touch= text entry = new position of the cursor
        cursor= ((xt-5)/12) + (((yt-5)/12)*25) ; //text begins at 5,5
        if (cursor >(int)ligne.length())
            cursor=ligne.length()-1;
        //printf("ed.displayLine cursor=%d  len=%d\n",cursor,ligne.length()) ;
    }//end while loop
    modele.lignes[selectedline]=ligne;
}
void Ed::saveAs() {//change the model name.MDX  and save , with or without a .MDP  
    string ligne = modele.filename; //name of the original file, 8.3 , inclusive the extension .MDX or .MDM
    //line display status
    int cursor  =0 ;//position of the cursor (text is insered before the cursor)
    const char kbA[]= "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; // display font width= 24 heigth=32 
    const char kb3[]= "0123456789+- .:#=@_\"!?%&$";
    const int  yc2=215; // command line heighth=25
    const int  y3=148; // two lines with kb3 h=32*2
    const int  ya=84; // two lines with kba or kbA h=32*2
    const int   xc11=0, xc12=160,xc13=220,xc14=270;
    rc.lcdptr->Cls();
    // text zone for  4 text lines font 12*16 max 25 char/line
    rc.lcdptr->Pen('\x01');
    rc.lcdptr->Rectangle(2,2,318,71, getColor(FOREGROUND_TEXT));
    rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
    //paint the permanent lines
	rc.lcdptr->Rectangle(0,ya,LCDX,ya+(32*4), getColor(BACKGROUND_CMD));
	rc.lcdptr->Textg( kbA,0,ya,'\03',getColor(FOREGROUND_CMD),2,2);//2lines
	rc.lcdptr->Textg(kb3,0,y3,'\03',getColor(FOREGROUND_CMD),2,2);// show
    // bottom command line
    rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
    rc.lcdptr->Rectangle(0,pix_y,LCDX,LCDY, getColor(BACKGROUND_CMD));
    int yb=LCDY-marge+5; //upper alignement of font 3
    rc.lcdptr->Textcmd(string("SAVE"),xc11,yb);
    rc.lcdptr->Textcmd(string("STOP"),xc12,yb);
    rc.lcdptr->Textcmd(string("<Del"),xc13,yb);
    rc.lcdptr->Textcmd(string("Del "),xc14,yb);
	string errorMessage = " ";
    while (1) {//process each touch
        int xt,yt;//touch coordinates
        //paint the text 
		//printf(" ligne =%s\n",ligne.c_str());
        rc.lcdptr->Rectangle(0,0,LCDX,font_y*4, getColor(BACKGROUND_TEXT)); //erase the text and the cursor !
        rc.lcdptr->Textg(ligne,5,5,'\03',getColor(FOREGROUND_TEXT),1,1);//font 12*16, repaint the text
		rc.lcdptr->Textg(errorMessage,5,5+font_y,'\03',RED,1,1);
        // cursor
        int xc= cursor;
        rc.lcdptr->Textg("_",5+(xc*12),5,'\03',RED,1,1);//font 12*16
        rc.lcdptr->GetTouch(  &xt,  &yt);
        if ( yt > yc2) {//within the command line
            if (xt>xc14) { // delete the char right
                if ((int)ligne.size()>cursor)
                    ligne.erase(cursor,1);
                continue;
            }
            if (xt>xc13) { // delete left
                if (cursor>0) {
                    cursor--;
                    ligne.erase(cursor,1);
                }
                continue;
            }
            if (xt>xc12) {
                //STOP without file save
                return;
            }
			// option SAVE
			// check the filename, if error message + continue
			errorMessage="";
			int n =ligne.size();
			if (n>12){
				errorMessage ="trop long (max 8.3)";
				continue;
			}
			string extension = ligne.substr(n-4,4);	
			string basename= ligne.substr(0,n-4);	
			if ((extension.compare(".MDX")==0) || (extension.compare(".MDM") ==0))
				;
				else{
					errorMessage ="Ext incorrect ="+extension;
					continue;
				}
			Filey f; 
            if (f.fopenread(ligne)){
				errorMessage="fichier existant";
				f.ftoclose();
				continue;
			}
			//===save the model with the new name
			//printf ("New filename=%s\n",ligne.c_str());
			string orig_name= modele.filename;
			modele.filename =ligne;
			modele.save();
			//====save the param here ...if needed
			// minimum : create a empty .MDM because the param_restore needs a file  2014073
			if( extension.compare(".MDX")==0){
				Filey fichier;
				if (fichier.fopenwrite(basename+".mdp")) {
					string z;
					z= "# empty .MDM";
					fichier.fputline(z);
					fichier.ftoclose();
				}
		}
	
 
        }
        if (yt>ya) { //keyboard char entry
            int y= (yt-ya)/32; //row
            int x= xt/24;      //column
            char z='?';
            if (y==0)        z=kbA[x];
            else if (y==1)  z=kbA[x+13];
            else if (y==2)  z=kb3[x];
            else            z=kb3[x+13];
            //printf("kb ligne=%d col=%d  char=%c\n",y,x,z);
            ligne.insert(cursor,1,z);//insert this char at the cursor position
            cursor++;
            continue;
        }
        //text entry = new position of the cursor
        cursor= ((xt-5)/12) + (((yt-5)/12)*25) ; //text begins at 5,5
        if (cursor >(int)ligne.length())
            cursor=ligne.length()-1;
        //printf("ed.displayLine cursor=%d  len=%d\n",cursor,ligne.length()) ;
    }//end while loop
	// save the model
    
}
