//extern Serial pc;
/* file processing with the 4D sd card
   device : initialized by Lcd4D and lcdhw


 */
// sd card fat access
#include "core.h"
extern rccl_data rc; //common data
int Lcd4D::GetFileSize() {//within the sd file read
	unsigned char answer[4];
	//printf("sd4D_read_init GetFileSize\n");
	for (int i=0; i<4; i++) {
		//printf(".\n");
		answer[i]=  getc(); // 4 bytes bg endian
		//printf("answer=%i\n",answer[i]);
	}
	putc(ACK);
	//If you send NAK to the filelength you should then receive an ACK and the display should be ready for the next command.
	int len =  answer[2]*256 + answer[3];
	printf("sd4D_read_init GetFileSize=%i\n",len);
	return len; //the two first are 0
}
bool Lcd4D::fexist(string filename) {
	//printf("sd4D_file exist =%s \n",filename.c_str());
	char cmd[3];
	cmd[0]='\x40';
	cmd[1]='\x64';  //read directory
	CmdS(cmd,2);
	putString(filename); //send the string and append with \0
	//wait_ms(5);
	//get answer
	int x =0;
	while (true){
		char c = getc();
	    if( c== ACK || c==NAK)
			break;
		x++;
	}
	if (x==0) return false;
	return true;
}


bool Lcd4D::fopenread(string filename) {
    if (!fexist(filename))
		return false;
	//printf("sd4D_read_init file=%s \n",filename.c_str());
	char cmd[3];
	cmd[0]='\x40';
	cmd[1]='\x61';
	cmd[2]='\x01' ;
	CmdS(cmd,3);
	putString(filename); //send the string and append with \0
	wait_ms(5);
	file_length = GetFileSize(); //read the file length
	//printf("sd4D_read_init file=%s length=%i\n",filename.c_str(), file_length);
	file_length_transfer=file_length;
	if (file_length==0) {
		printf("sd4D_read_init file=%s non exists \n",filename.c_str());
		putc(NAK);//ask to terminate the receive
		getc(); //If you send NAK to the filelength you should then receive an ACK and the display should be ready for the next command.
		wait_ms(1);
		return false;
	}
	return true;
}
bool Lcd4D::fgetline(string& line) { //without buffer HANDSHAKE=1
	unsigned char c ='\0';
	line.clear();
	while (file_length_transfer>0) {
		c=getc();
		file_length_transfer--;
		putc(ACK);
		if (c=='\n')
			return true;
		line += c;
	}
	Ack();
	c=getc(); //!!!!!!!!!!! NAK qui ne  ne devrait pas exister
	return false; //eof
}
vector<string> Lcd4D::fgetlist() {//directory list, without selection
	vector<string> dirlist;
	//printf ("file4D fgetlist\n");
	char cmd[6];
	string filter;
	filter = string("*.*");
	cmd[0]='\x40';
	cmd[1]='\x64';
	CmdS(cmd,2);
	putString(filter); //send the string and append with \0
	unsigned char c;
	string filename;

	while (1) {
		c=getcB();
		if (c==NAK) {
			printf("file4D error fgetlist %s\n",filename.c_str());  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			return dirlist;
		}
		if (c==ACK) {
			//printf("file4D return\n");
			return dirlist;
		}
		if (c=='\n') {
			dirlist.push_back(filename);
			//printf("file4D dirlist filename=%s\n",filename.c_str());
			filename.clear();
			continue;
		}
		filename += c;
		//printf("filename = %s\n",filename.c_str());
	}
}
bool Lcd4D::fopenwrite(string filename) {
	char cmd[4];
	// this open is a simple erase the existing file
	//printf("fopenwrite: erase %s\n",filename.c_str());  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	cmd[0]='\x40';
	cmd[1]='\x65';
	CmdS(cmd,2);
	putString(filename);
	yfilename=filename; // store the filename
	getc(); //ack or nak
	//printf ("           return code= %i\n",c);   //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	return true;
}
void Lcd4D::fputline(string& s) {//append a line, or any string   maximum 100 bytes !!blocking 
	char cmd[4];
	cmd[0]='\x40';
	cmd[1]='\x74';
	cmd[2]='\x80' ; //append mode, no handshaking (high performance)for max 100 bytes
	CmdS(cmd,3);
	putString(yfilename);
	unsigned char x = s.length();
	if (x>100) {
		printf("fputline error length> 100 %s\n",s.c_str()); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		return;
	}
	//file length
	putc('\0');
	putc('\0');
	putc('\0');
	putc(x);
	Ack();
	for (int i=0; i<x; i++) { 
		putc(s.at(i));
		// wait_ms(1);
	}
	Ack();
}
