/* load a model file ->internal Mdx object , used by Ed for editing */
#include "core.h"
#ifdef DEBUGP
extern Serial pc;
#endif
Mdx::Mdx() {}
Mdx::Mdx(string f) {//load filename 8.3 into the vector lignes
	filename=f;
	Filey fichier;
	string line;
	fichier.fopenread(f);
	while(fichier.fgetline(line)) {
		lignes.push_back(line);
		//printf("Mdx create %s\n",line.c_str());
	}
	//printf("Mdx open %s\n",filename.c_str());
}
void Mdx::save() {
	Filey fichier;

	fichier.fremove(filename); // 20140501 bug : file open error when file updated by the pc (updated file date > 20080101 )  this bug occurs with recent library
	if(fichier.fopenwrite(filename)) {
		for(int i=0; i<(int)lignes.size(); i++) {
			string z = lignes[i]+"\n";
			fichier.fputline(z);
			//printf("mdx save %s",z.c_str());
		}
		fichier.ftoclose();
		//printf("Mdx saved file= %s\n",filename.c_str());
	}
}
string Mdx::getline(int i) { //the the line i from this model (line from 0 )
	if(i<0) i=0;
	if(i> (int)lignes.size()-1) i=  lignes.size()-1;
	return lignes.at(i);
}
vector<string> Mdx::gettokens(string z) {//get the tokens from line i
	vector<string> tokens ;
	int y =z.find_first_of('#');
	if(y==0) return tokens ;  //empty
	z= z.substr(0,y);     // remove comments after the #
	Tokenize(z,tokens," \t");
	// for (int i=0;i< tokens.size();i++) printf("Token=%s\n",tokens[i].c_str());
	return tokens;
}
vector<string> cleanline(string z) {//get the tokens from line i
	vector<string> tokens ;
	if(z.length()>1 && z.substr(0,2)=="#4") { // preprocessing : if the lines begin with #4 :delete these 2 char
		string z4 = z.substr(2,z.length()-2);
		z=z4;
	}
	int y =z.find_first_of('#');
	if(y==0) return tokens ;  //empty
	z= z.substr(0,y);     // remove comments after the #
	Tokenize(z,tokens," \t");
	//for (int i=0; i< tokens.size(); i++) printf("Token=%s\n",tokens[i].c_str());
	return tokens;
}
/*void Tokenize(const string& str, vector<string>& tokens,  const string& delimiters = " ") {
    // from http://www.oopweb.com/CPP/Documents/CPPHOWTO/Volume/C++Programming-HOWTO-7.html
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);    // Skip delimiters at beginning.
    string::size_type pos     = str.find_first_of(delimiters, lastPos);    // Find first "non-delimiter".
    while (string::npos != pos || string::npos != lastPos)  {   //string::npos = not found
        tokens.push_back(str.substr(lastPos, pos - lastPos));// Found a token, add it to the vector.
        lastPos = str.find_first_not_of(delimiters, pos);// Skip delimiters.  Note the "not_of"
        pos = str.find_first_of(delimiters, lastPos);// Find next "non-delimiter"
    }
}*/
void Tokenize(const string& str, vector<string>& tokens,  const string& delimiters = " ") { //spilt -> tokens ; a string variable is ONE token
	// from http://www.oopweb.com/CPP/Documents/CPPHOWTO/Volume/C++Programming-HOWTO-7.html
	// + making one token from a string variable ("xxx xxxx xxxx" is one token)
	string::size_type lastPos = str.find_first_not_of(delimiters, 0);    // Skip delimiters at beginning.
	string::size_type pos     = str.find_first_of(delimiters, lastPos);    // Find first "non-delimiter".
	string x ="";
	bool begin, end ;
	while(string::npos != pos || string::npos != lastPos)  {    //string::npos = not found
		if(x.length()>0)
			x = x +" "+ str.substr(lastPos, pos - lastPos); //Found a token, add it o the current string var
		else
			x = str.substr(lastPos, pos - lastPos);
		begin = (x.substr(0,1)== "\"") ; // true if x begins with  a double quote
		end   = (x.substr(x.length()-1,1)== "\"") ; // true if x ends  with  a double quote
		if(!begin || (begin && end)) {
			tokens.push_back(x);// Found a token, add it to the vector.
			x = "";
		}
		lastPos = str.find_first_not_of(delimiters, pos);// Skip delimiters.  Note the "not_of"
		pos = str.find_first_of(delimiters, lastPos);// Find next "non-delimiter"
	}
}
int Mdx::getnblignes() {
	return lignes.size();
}
/*
void Mdx::replace (int line, string oldvalue, string newvalue){
    string z = lignes[line];
    int y = z.find_first_of('#');
    if (y>=0)
        z= z.substr(0,y);     // remove comments after the #
    while(1){
        int pos=z.find(oldvalue);
        if (pos<0)
            break;
        z.replace (pos,oldvalue.size(),newvalue);
    }
    lignes[line]=z;
}
void Mdx::debugprintf(){
    printf("Mdx filename=%s  size=%d\n",filename.c_str(),lignes.size());
    for (int i=0; i<lignes.size();i++)
        printf("Mdx i=%d %s\n",i,lignes[i].c_str());
    printf("EOF*************************\n");
}
void token_printf( vector<string> tokens){
    printf("tokens=");
    for (int i =0;i< tokens.size();i++)
        printf(" %s",tokens[i].c_str());
    printf("\n");
}
*/