/* The main dialog is  a perpetual loop
-each dialog program returns a "dialog" code, in fact chaining the next program
-this perpetual loop is initialized with a first dialog, depending on the "state" after the start
This program rccl_dialog() is called after the start of the microprocessor (start = trying to load and run the former model
*/
#include "core.h"
#ifdef DEBUGP
extern Serial pc;
#endif
extern rccl_data rc; //common data
void rccl_dialog() {
    int dialog = MENU_START;//this is the first program call or a restart of the dialog
    while (1) {
        //printf("menu dialog  = %d\n",dialog);
        if (dialog==MENU_START) {//call a first menu depending on the "state"
            if ( rc.current_file =="")
                dialog = MENU_SELECT;//choose a new file
            else if ( rc.calcptr ==NULL )
                dialog = MENU_LOAD; //load the model for this filename
            else if ( !rc.calcptr->ready_to_calc)
                dialog = MENU_ERROR;//display the error messages
            else
                dialog = MENU_NORMAL; //running
            /* this is the normal case: display the on line menu
            - current file is  known, is loaded and is running
            -> his is the "online" menu
            after a "touch", the program returns the dialog code for the next program: normal case menu_normal  */
            continue;
        }
        //----- call the next program, depending on the returned dialog code----------------
        if (dialog==MENU_SELECT)      {
            dialog=menu_select(); // defined in  menu_select.cpp
            continue;
        }
        if (dialog==MENU_LOAD)      {
            dialog=menu_1oad(); //defined below
            continue;
        }
        if (dialog==MENU_ERROR)      {
            dialog=menu_error(); // defined in menu_error.cpp
            continue;
        }
        if (dialog==MENU_NORMAL)      {
					dialog=menu_normal();
					/*
					if (rc.jetiptr!=NULL)
						dialog=menu_normal_jeti(); //defined in menu_jeti.cpp
				  	
					else
            dialog=menu_normal(); //defined in menu_normal.cpp */
					continue;
        }
        if (dialog==MENU_ONLINE) {
            dialog=menu_online(); //defined in menu_online.cpp
            continue;
        }
        if (dialog==MENU_OFF)    {
            dialog=menu_off();    //defined below
            continue;
        }
        if (dialog==PARAM_UPD)   {
            dialog=param_upd(); //defined in  menucalc.cpp
            continue;
        }
        if (dialog==PARAM_ASSIGN)   {
            dialog=param_assign(); //defined in  menucalc.cpp
            continue;
        }
        if (dialog==VAR_DISPLAY) {
            dialog=var_display();  //defined in  menucalc.cpp
            continue;
        }
        if (dialog==MENU_EDITOR)   {
            dialog=menu_ed(); //defined in  menu_ed.cpp
            continue;
        }
				if (dialog==MENU_EDITOR_RO)   {//readonly
            dialog=menu_ed_ro(); //defined in  menu_ed.cpp
            continue;
        }
        if (dialog==VAR_DISPLAY_SEL)   {
            dialog=var_display_sel(); //defined in  menucalc.cpp
            continue;
        }
        if (dialog==VAR_GRAPH)   {
            dialog=var_graph(); //defined in  menucalc.cpp
            continue;
        }
        if (dialog==MENU_SETUP)   {
            dialog=menu_setup(); //defined in  menu_setup.cpp
            continue;
        }
		if (dialog==MENU_SD4D)   {
            dialog=menu_sound(); //defined in  sound.cpp
            continue;
        }
		
#ifdef JETI
        if (dialog==MENU_JETI)   {
            dialog=menu_jeti(); //defined in  menu_setup.cpp
            continue;
				}
        if (dialog==MENU_JETI_FOLLOW)   {
            dialog=menu_jeti_follow(); //defined in  menu_setup.cpp
            continue;					
        }
		if (dialog==MENU_LOGVIEW)   {
            dialog=menu_logview(); //defined in  menucalc.cpp
            continue;
        }
		if (dialog==MENU_LOGEXP)   {
            dialog=menu_logexp(); //defined in  menucalc.cpp
            continue;
        }		
		if (dialog==MENU_LOGDEL)   {
            dialog=menu_logdel(); //defined in  menucalc.cpp
            continue;
        }
						
		
#endif
        //if dialog not found...the watchdog reloads..
#ifdef DEBUGP
        pc.printf("menu :error\n");
#endif
    }//perpetual loop
}
//-------------top level menus (choice deppending on the status ----------------

dialog menu_1oad() {
    /* current file name is known but not loaded (or calc is cleared)
    -load  the current file
    - no error -> rc.calcptr->ready_to_calc = true
        warning messages are in the rc.calcptr->errors vector
    - errors  -> rc.calcptr->ready_to_calc = false
        in rc.calcptr->errors vector
     */
    //printf("menu menu_1()\n"); 
	
    rc.calcptr= new (nothrow) Calc(rc.current_file);
	  rc.sndptr->putFile(rc.current_file);	
	  rc.calcptr->setVarL ("@H1",1);
    return MENU_START;
}

dialog menu_off() {
   //printf("menu :power off \n");
   
  power(0); //kill the power or remain in aloop
	return MENU_START;
}
