/* display the error messages*/
#include "core.h"
#ifdef DEBUGP
extern Serial pc;
#endif
extern rccl_data rc; //common data
dialog menu_error() {//menu to display the error messages
    char font ='\x03';
    int font_y,font_x;
    const int marge=25; //height of the command line
    int y=0;
    int x=0;
    int step_y,step_x;
    int xt,yt, n_y,n_x;
    //tabs 12pixels/char
    // const int ar_retry=0,ar_edit= 40 ,ar_cancel=80,ar_u=160, ar_d=190 ,  ar_l=220, ar_r=260;//tabs on the command line
    const int ar_retry=0,ar_edit= 50 ,ar_cancel=105,ar_u=190, ar_d=220 ,ar_l=250, ar_r=290;//tabs on the command line
    font_x=Lcd4D::font_x(font);
    n_x= LCDX/font_x;
    step_x=5 ;
    font_y=Lcd4D::font_y(font);
    n_y= (LCDY-marge)/font_y;
    step_y= n_y -2;
    while (1) {
        rc.lcdptr->Cls();
        string z,p,text;
        // bottom command line
        rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
        rc.lcdptr->Rectangle(0,LCDY-marge,LCDX,LCDY, getColor(BACKGROUND_CMD));
        int yb=LCDY-marge+5; //upper alignement of font 3
        rc.lcdptr->Textcmd(string("Try"),ar_retry,yb);
        rc.lcdptr->Textcmd(string("Edit"),ar_edit,yb);
        rc.lcdptr->Textcmd(string("Cancel"),ar_cancel,yb);
        rc.lcdptr->ArrowCmd(ARROW_UP  ,ar_u,yb);
        rc.lcdptr->ArrowCmd(ARROW_DOWN,ar_d,yb);
        rc.lcdptr->ArrowCmd(ARROW_LEFT,ar_l,yb);
        rc.lcdptr->ArrowCmd(ARROW_RIGHT,ar_r,yb);

        for (int i =0; (i<n_y)&&(i<(int)rc.calcptr->errors.size()-y); i++) {
            string z=rc.calcptr->errors[i+y];
            string zc = z.substr(x,n_x);
            rc.lcdptr->Textg (zc,0,i*font_y, font, getColor(FOREGROUND_TEXT),1,1);
        }
        rc.lcdptr->GetTouch(  &xt,  &yt);
        if ( yt>LCDY-marge) { // selection within the command line
            int nblines= rc.calcptr->errors.size();
            if (xt> ar_r) {
                x=min(MAXLINE-n_x ,x+step_x);     //shift right
                continue;
            }
            if (xt> ar_l) {
                x=max(0,x-step_x);    //shift left
                continue;
            }
            if (xt> ar_d) {
                y=min(max(0,nblines - n_y+2),y+step_y);
                continue;
            }
            if (xt> ar_u) {
                y=max(0,y-step_y);
                continue;
            }

            if (xt> ar_cancel) {// quit and select another model
#ifdef DEBUGP
                pc.printf("menu_error -> cancel \n");
#endif
                rc.lcdptr->Cls();
                rc.current_file ="";
                //optional : soft reset
                return MENU_START;
            }
            if (xt> ar_edit) { //edit the model
#ifdef DEBUGP
                pc.printf("menu_error -> edit\n");
#endif
                rc.lcdptr->Cls();
                return MENU_EDITOR ;
            }
            // retry
#ifdef DEBUGP
            pc.printf("menu_error -> retry\n");
#endif
            rc.lcdptr->Cls();
            delete rc.calcptr; //destroy the Calc object !!!
            //optional : soft reset
            rc.calcptr =NULL;
            return MENU_START;
        }
    }
}