#include "core.h"
extern rccl_data rc; //common data

dialog menu_setup() {/* Various parameters of the transmitter*/
	rc.lcdptr->Cls();
	Grt t1(0,0,8,1,'\x03');
	t1.setText("Touch:");
	Grt t1_0(90,0,4,1,'\x03');
	t1_0.setText("Ctrl");
	t1_0.selectable=true;
	Grt t1_1(150,0,5,1,'\x03');
	t1_1.setText("Recal");
	t1_1.selectable=true;
	Grt t2(0,t1.y1+40,8,1,'\x03');
	t2.setText("Colors:");
	Grt t2_0(90,t1.y1+40,3,1,'\x03');
	t2_0.setText("RS");
	t2_0.selectable=true;
	Grt t2_1(130,t1.y1+40,3,1,'\x03');
	t2_1.setText("BW");
	t2_1.selectable=true;
	Grt t2_2(170,t1.y1+40,3,1,'\x03');
	t2_2.setText("WB");
	t2_2.selectable=true;
	Grt t3(t2.y1+20);
	t3.selectable=true;
	t3.setText("SAVE  ");
	Grt t4(0,t3.y1+20,6,1,'\x03');
	t4.selectable=true;
	t4.setText("SOUND  ");
	//slider
	int ys= t3.y1+25;// center of the slider line
	Gr slider(100,ys -8,220,ys+8);//the slider
	Gr sliderTouch(100,ys -8,220,ys+8); //the slider 120 pixels
	sliderTouch.selectable=true;
	Grt t5(0,t4.y1+20,20,1,'\x03');
	t5.selectable=true;
	t5.setText("Files SD (4D)  "); 
	#ifdef WATCHDOG
	Grt t6(0,t5.y1+20,20,1,'\x03');
	t6.selectable=true;
	t6.setText("->Watchdog"); 
	#endif
	
	
	Grt t9(LCDY - 20);
	t9.selectable=true;
	t9.setText("BACK");

	int xt,yt;//touch ccordinates
	bool touchmode=true;// true =press false=moving
	while (1) {
		rc.lcdptr->Rectangle(slider.x1,slider.y1,slider.x2,slider.y2,getColor(BACKGROUND_CMD));
		int xs= 100 + rc.lcdptr->calibrate.volume-7 ;// calibrate 7..127 slider 100..220
		//printf ("volume =%i  xs = %i\n",rc.lcdptr->calibrate.volume,xs);
		rc.lcdptr->Point(xs,ys,RED);
		if (touchmode) {
			rc.lcdptr->GetTouch(&xt,&yt) ;//get touch
			//printf("Menu_select touch x=%d y=%d\n",xt,yt);
			if (t1_0.selected(xt,yt)) {
				rc.lcdptr->CalibrateCtrl();
				return MENU_START;
			}
			if (t1_1.selected(xt,yt)) {
				rc.lcdptr->Calibrate();
				return MENU_START;
			}
			if (t2_0.selected(xt,yt)) {
				rc.lcdptr->colorChoice=LCD_RS;
				rc.lcdptr->ChangeColor();
				return MENU_START ;
			}
			if (t2_1.selected(xt,yt)) {
				rc.lcdptr->colorChoice=LCD_BW;
				rc.lcdptr->ChangeColor();
				return MENU_START ;
			}
			if (t2_2.selected(xt,yt)) {
				rc.lcdptr->colorChoice=LCD_WB;
				rc.lcdptr->ChangeColor();
				return MENU_START ;
			}
			if (t3.selected(xt,yt)) {
				rc.lcdptr->CalibrateWrite(); //save the tx parameters
				return MENU_START;
			}
			if (t4.selected(xt,yt)) {
				rc.sndptr->putFile("2BES");
				continue;
			}
			if (sliderTouch.selected(xt,yt)&& abs(xt-xs)<10) { // touch in the slider...change to moving touch
				touchmode=false;
				continue;
			}
			if (t5.selected(xt,yt)) {
				delete rc.calcptr; //destroy the Calc object !!! -> stop the watchdog and free memory (somme of the operations are too long)
              	rc.calcptr =NULL;
				return MENU_SD4D ; 
			} 
			#ifdef WATCHDOG
			if (t6.selected(xt,yt)) {
				#ifdef DEBUGP
				printf("menu_setup kill -> watchdog\n");
				rc.lcdptr->PinDump();
			//	rc.lcdptr->PinRestore();
			//	rc.lcdptr->PinDump();
				#endif
				while(1)  //kill 
					;
			} 
			#endif
			if (t9.selected(xt,yt)) return MENU_START;
		} else {//touchmode=false
			touchmode=! rc.lcdptr->GetTouchSlider(&xt,  &yt);
			int v = xt-100+7;
			if (v<7)
				v=7;
			if (v>127)
				v=127;
			rc.lcdptr->calibrate.volume = xt-100+7;
			rc.lcdptr->setVolume();
		}
	}
}
