#include "core.h"
/* transmitter mixer

 */
Curve::Curve() {

}
void Curve:: addPoint(short x, short y) {//add a point to the definition of the mixer curve
    vx.push_back(x);
    vy.push_back(y);
    //printf ("mix pos=%d  add x=%d y=%d \n",vx.size(),x,y);
}
short Curve::get(short xvalue) { // compute the output value at x
    // find the low value (highest point with x <= xvalue)
    int ixmin = -1;
    short xmin=-100*TOINT;
    for (int i=0; i<(int)vx.size(); i++) {
        if (vx[i] <= xvalue && vx[i]>=xmin) {
            ixmin=i;
            xmin=vx[i];
        }
    }

    if (ixmin== -1) { //error: no point below xvalue - return the lowest point
        xmin= 100*TOINT;
        for (int i=0; i<(int)vx.size(); i++) {
            if (vx[i] <= xmin) {
                ixmin=i;
                xmin=vx[i];
            }
        }
        //printf ("mix ixmin=%i\n",ixmin);
        return vy[ixmin];
    }
    // find the high value (lowest point with x >= xvalue)
    int ixmax = -1;
    short xmax= 100*TOINT;
    for (int i=0; i<(int)vx.size(); i++) {
        if (vx[i] >= xvalue && vx[i]<= xmax) {
            ixmax=i;
            xmax=vx[i];
        }
    }
    if (ixmax==-1) { //error: no point above xvalue - return the hihest point
        xmax= -100*TOINT;
        for (int i=0; i<(int)vx.size(); i++) {
            if (vx[i] >= xmax) {
                ixmax=i;
                xmax=vx[i];
            }
        }
        return vy[ixmax];
    }
    return interpol(xvalue,vx[ixmin],vy[ixmin],vx[ixmax],vy[ixmax]);
}
int interpol(int x,int x1,int y1,int x2,int y2) {// linear interpol
    //y(x)is linear between (x1,y1) and(x2,y2)
    //printf("interpol---- x=%i x1=%i y1=%i x2=%i y2=%i \n",x,x1,y1,x2,y2);
    if (x<=x1)      //truncates
        return y1;
    if (x>=x2)
        return y2;
    float dx = x2-x1;
    float dy = y2-y1;
    float ddx = x-x1;
    float ddy;
    ddy = (ddx * dy)/ dx;
    return  y1+ (int)ddy;
}