#include "core.h"
/* transmitter sound functions using the 4D sound and sd card
   langage depending functions
   here the  translation number -> sound /french
   traduction nombre -> synthese vocale en francais
   utilise les fonctions xput et nput
 */
extern rccl_data rc; //common data
/*void Snd::conv (int nombre) {

    conv3(nombre);
    zput(1000);
}*/
void Snd::conv3 (int nombre  ) { //conversion d'un nombre positif de 0 a 999 en sons par appel de _xput et _nput
    int centaine,dizaine,unit;
    centaine = nombre /100;
    dizaine = (nombre-centaine*100)/10;
    unit = (nombre-centaine*100-dizaine*10);
    //printf (" conv3 ---------Nombre=%i -> %i %i %i\n",nombre,centaine,dizaine,unit);
    //  centaines
    if (centaine==1)
        nput(100);
    else if (centaine>0) {
        nput(centaine);
        nput(100);
    }
    //dizaines et unites
    if (dizaine ==0 ) { //dicter directement les unites
        nput(unit);   // un ...neuf
        return;
    }
    if (dizaine ==1) {
        nput(10+unit);  // onze douze ..dix neuf
        return;
    }
    //----------exclusivement pour francais de france soixante quinze au lieu de septante cinq
#ifdef SPEAK_LAN_FR
    if (dizaine ==7 ||dizaine ==9) {
        nput(10*(dizaine-1));
        if (unit==1 && dizaine ==7)
            xput("1E");  // "et"
        nput(10+unit);  // onze douze ..dix neuf
        return;
    }
#endif
    nput(dizaine*10);
    if (unit==0)
        return;
    if (unit==1)
        xput("1E");  // "et"
    nput(unit);
}
void Snd::conv2 (int nombre  ) { //conversion partie fractionnaire 2 dcimales
    int dizaine,unit;
    dizaine = (nombre)/10;
    unit = (nombre-dizaine*10);
    //printf (" conv2 ---------Nombre=%i -> %i %i \n",nombre,dizaine,unit);
    //dizaines et unites
    if (dizaine ==1) {
        nput(10+unit);  // onze douze ..dix neuf
        return;
    }
    //----------exclusivement pour francais de france soixante quinze au lieu de septante cinq
#ifdef SPEAK_LAN_FR
    if (dizaine ==7 ||dizaine ==9) {
        nput(10*(dizaine-1));
        if (unit==1 && dizaine ==7)
            xput("1E");  // "et"
        nput(10+unit);  // onze douze ..dix neuf
        return;
    }
#endif
    if (dizaine==0) {
        nput(0);
        nput(unit);
        return;
    }
    nput(dizaine*10);
    if (unit==0)
        return;
    if (unit==1 )
        xput("1E");  // "et"
    nput(unit);
}

void Snd::conv1 (int unit  ) { //conversion partie fractionnaire 1 dcimales
    //printf (" conv1 ---------Nombre=%i \n",unit);
    //dizaines et unites
    nput(unit);
}
/*void rccl_test() { // test program


	float test[3]={ 65.71,125,-77.77};
    for (int i=0 ; i< 3; i++) {
        rc.sndptr->putValue(test[i],0);
        rc.sndptr->zput(1000);
        rc.sndptr->putValue(test[i],1);
        rc.sndptr->zput(1000);
        rc.sndptr->putValue(test[i],2);
        rc.sndptr->zput(1000);
    }

		rc.sndptr->putFile("BREAK1");
		rc.sndptr->putFile("BREAK2");

}*/