/* menu for Jeti and the programs independant of the "hardware" jeti protocol
- dialog_menu is a simulated JetiBox
- sensor_detect finds the sensors wich are connected
*/
#include "core.h"
//#define JETI_TRIGGER    
extern rccl_data rc; //common data
#ifdef JETI_TRIGGER
DigitalOut trigger(p27) ;//pin 27 on after a selection, to trigger the logical analyzer
#endif
bool modeLong;
void jetiCmd(char x) { //send a command trough the JetiBox protocol
	if (!modeLong)
		rc.sndptr->putFile("2BE");
	rc.jetiptr->putJeti(x);
}
dialog menu_jeti() {//manual use of a simulated jetibox
	
	if (rc.jetiptr==NULL)
		return MENU_START;
	rc.jetiptr->jeti_box_busy=true;
	//printf(" menu_jeti\n");
	rc.lcdptr->Cls();
	// display the 2 lines (2*16 char)
	Grt ligne1 = Grt(5,1,16,2,'\x01');
	Grt ligne2 = Grt(5,22,16,2,'\x01');
	Grt ligneRef=Grt(5,43,16,2,'\x01');
	ligneRef.setText("01234567890123456");

	// jeti box buttons
	Gra left = Gra(5,70);
	left.selectable=true;
	left.setArrow(ARROW_LEFT);
	Gra up = Gra(35,70);
	up.setArrow(ARROW_UP);
	up.selectable=true;
	Gra down = Gra(65,70);
	down.setArrow(ARROW_DOWN);
	down.selectable=true;
	Gra right = Gra(100,70);
	right.setArrow(ARROW_RIGHT);
	right.selectable=true;
	Grt erase= Grt(150,70,6,1,'\x03');
	erase.setText("Erase");
	erase.selectable=true;
	Grt modeT= Grt(5,90,10,1,'\x03');
	modeT.selectable=false;
	modeT.setText("Long touch");
	Grt modeON = Grt(200,90,4,1,'\x03');
	modeON.selectable=true;
	modeON.setText("ON");
	Grt modeOFF = Grt(230,90,4,1,'\x03');
	modeOFF.selectable=true;
	modeOFF.setText("OFF");
	modeLong=false;

	//Node explorer
	Grt nodeId = Grt(5,110,3,1,'\x03');
	Grt var[5] ={Grt(40,110,20,1,'\x03'),Grt(40,130,20,1,'\x03'),Grt(40,150,20,1,'\x03'),Grt(40,170,20,1,'\x03'),Grt(40,190,20,1,'\x03')};
	
	// bottom command line
	int const marge = 25; //command line
	rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
	rc.lcdptr->Rectangle(0,LCDY-marge,LCDX,LCDY, getColor(BACKGROUND_CMD));
	Grt back = Grt(5,215,5,1,'\x03');
	back.setText("Back");
	back.selectable=true;
	int xt,yt;//touch coo.
	while (1) {
		do {
			rc.jetiptr->jeti_replace();
			ligne1.setText(rc.jetiptr->get1());
			ligne2.setText(rc.jetiptr->get2());
			char str[20];
			int id=rc.jetiptr->node_find();
			if (id>0) {
				rc.jetiptr->from=id;
				sprintf(str,"%d",id);
				nodeId.setText(str);
				vector <string> v;
				rc.jetiptr->getVar(id,v);
				for (int i=0; i<5; i++) {
					if (i>=(signed)v.size()) {
						var[i].setText(" ");
					} else {
						sprintf(str,"%s   ",v[i].c_str());
						var[i].setText(str);
					}
				}
			} else {
				nodeId.setText("---");
			}
			
			modeT.setText(modeLong ? "Long touch":"One touch");
			#ifdef JETI_TRIGGER
			trigger = 0;
			#endif
		} while (modeLong ?(rc.lcdptr->GetTouchNBC(&xt,  &yt)==false): (rc.lcdptr->GetTouchNB(&xt,  &yt)==false));     //end of the do statement repainting the text waiting for a touch
		//printf(" menu_jeti selection\n");
		#ifdef JETI_TRIGGER
			trigger = 1;
			wait_us(2);
			trigger = 0;
			#endif
		
		if (back.selected(xt,yt)) break;
		if (left.selected(xt,yt))    { jetiCmd(JETI_LEFT); printf("L\n");}
		if (right.selected(xt,yt)) 	jetiCmd(JETI_RIGHT);
		if (up.selected(xt,yt))    	jetiCmd(JETI_UP);
		if (down.selected(xt,yt))  jetiCmd(JETI_DOWN);
		if (erase.selected(xt,yt))	jetiCmd(JETI_ERASE);
		if (modeON.selected(xt,yt))	{
			modeLong=true; //continuous "touch" transmit continuously
		}
		if (modeOFF.selected(xt,yt))	{
			modeLong=false;//each touch produces only ONE transmission to the module
		}
	}
	rc.jetiptr->jeti_box_busy=false;
	return MENU_START;
}
//=========================================================
dialog menu_jeti_follow( ) {//manual use of a simulated jetibox
	if (rc.jetiptr==NULL)
		return MENU_START;
	//printf(" menu_jeti\n");
	rc.lcdptr->Cls();
	// display the 2 lines (2*16 char)
	Grt ligne1 = Grt(5,1,16,2,'\x01');
	Grt ligne2 = Grt(5,22,16,2,'\x01');
	Grt ligneRef=Grt(5,43,16,2,'\x01');
	ligneRef.setText("01234567890123456");
	Grt ligneRxCount=Grt(60);

	//Node explorer
	Grt nodeId = Grt(5,110,3,1,'\x03');
	Grt var[5] ={Grt(40,110,20,1,'\x03'),Grt(40,130,20,1,'\x03'),Grt(40,150,20,1,'\x03'),Grt(40,170,20,1,'\x03'),Grt(40,190,20,1,'\x03')};//value of the variables from this node
	
	//performance 
	//Grt perform = Grt(85);
		
	// bottom command line
	int const marge = 25; //command line
	rc.lcdptr->Pen('\x00');   //set pen size 0 for a solid rectangle
	rc.lcdptr->Rectangle(0,LCDY-marge,LCDX,LCDY, getColor(BACKGROUND_CMD));
	Grt back = Grt(5,215,5,1,'\x03');
	back.setText("Back");
	back.selectable=true;
	int xt,yt;//touch coo.
	while (1) {
		do {
			char str[20];
			rc.jetiptr->jeti_replace();
			ligne1.setText(rc.jetiptr->get1());
			ligne2.setText(rc.jetiptr->get2());
	    sprintf(str,"Rx= %d",rc.jetiptr->rx_count);
			ligneRxCount.setText(str);
	/*		sprintf(str,"Full JETI read= %5.2f sec",((float)rc.jetiptr->perform)/100.0);
			perform.setText(str); */

			int id=rc.jetiptr->node_find();
			if (id>0) {
				sprintf(str,"%d",id);
				nodeId.setText(str);
				vector <string> v;
				rc.jetiptr->getVar(id,v);
				for (int i=0; i<5; i++) {
					if (i>=(signed)v.size()) {
						var[i].setText(" ");
					} else {
						sprintf(str,"%s   ",v[i].c_str());
						var[i].setText(str);
					}
				}
			} else {
				nodeId.setText("---");
			}
			
		} while (rc.lcdptr->GetTouchNB(&xt,  &yt)==false);     //end of the do statement repainting the text waiting for a touch
		if (back.selected(xt,yt)) break;

	}
	return MENU_START;
}
