#include "mbed.h"
#include "core.h"
#include <vector>
/*filey.c  :
1)file processing at line level, here implemented with the mbed local file system
2) directory list
*/
LocalFileSystem local("local");
extern Serial pc ;
bool Filey::fopenread(string filename){
		//printf("fopenread : %s\n",filename.c_str());
    string fx="/local/"+filename;
    fy = fopen(fx.c_str(), "r");
    if (fy == NULL) return false;
    return true;
}
bool Filey::fopenwrite(string filename){
	 //printf("fopenwrite : %s\n",filename.c_str());
    string fx="/local/"+filename;
    fy = fopen(fx.c_str(), "w");
    if (fy == NULL) return false; 
    return true;
}
void Filey::fremove(string filename){
	string fx="/local/"+filename;
	remove(fx.c_str());
}

void Filey::ftoclose(){
	  //printf("ftoclose\n ");
    fclose(fy);
}
bool Filey::fgetone(char& x) { //get one char , return true if found, false at eof
	//char z;  // comparaison non valable unsigned integer - negative constant
	int z;
	z = fgetc(fy);
	if (z==EOF)  
		return false;
	else{
		x= (char) z;
		return true;
	}
}
int Filey::getlen(){ // returns the length of the file (only open in red mode )
	/*fseek(seek to the end of the file)
ftell(get the file size in bytes)
fseek(again come to the begining of the file if you want to traverse the file) */
	fseek(fy,0,SEEK_END);
	int len = ftell(fy);
	fseek(fy,0,SEEK_SET);
	return len;
}
bool Filey::fgetline(string& s){
    char buf[200];
    bool ret=fgets(buf,200,fy); //with the \n
    if (!ret){
        fclose(fy);
        return false;
    }
    int i =0;
    while (i<199){
        if (buf[i]=='\n'|| buf[i]=='\r'){
            buf[i]='\0';
            break;
        }
        if(buf[i]=='\t') //replace a tab with a single space
            buf[i]=' '; 
        i++;      
    }    
    s = buf;
    return true;
} 
void Filey::fputline(string& s){ 
    fputs( s.substr(0,200).c_str(),fy);
}
vector<string> Filey::fgetlist(  ){
   //printf("Filey::Print dir list\n");  
   vector<string> dirlist;
   DIR *d = opendir("/local");               // Opens the root directory of the local file system
    struct dirent *p;
    while((p = readdir(d)) != NULL) {         // Print the names of the files in the local file system
      //printf("Filey::  %s\n", p->d_name);              // to stdout.
      dirlist.push_back( p->d_name);
    }
    closedir(d);
    //printf("Filey::  List Dir is Done\n");
    return dirlist;
}
vector<string> Filey::fgetlist(string prefix, string suffix  ){
   //printf("Print dir list prefix=%s suffix=%s\n",prefix.c_str(),suffix.c_str());  
   vector<string> dirlist;
   DIR *d = opendir("/local");               // Opens the root directory of the local file system
    struct dirent *p;
    int len = prefix.size();
    while((p = readdir(d)) != NULL) {         // Print the names of the files in the local file system
      vector<string> token;
      Tokenize( p->d_name,token,".");         
      if (token[1]!= suffix) continue;
      if( token[0].substr(0,len)!=prefix) continue;            
      dirlist.push_back( p->d_name);
      //printf("List Dir selected =%s\n", p->d_name); 
    }
    closedir(d);
    //printf("List Dir is Done\n");
    return dirlist;
}