#include "mbed.h"
#include "core.h"
/* from // http://mbed.org/forum/mbed/topic/508/
   + use the RTC backup registers
   see #define WATCHDOG to activate theses functionnalities
	 RTC Registers
	 LPC_RTC->GPREG0 = the control byte for the watchdog
	     ?? replace with RSID ??
		LPC_RTC->GPREG1 = value of the digital io pins from the Lcd (see lcdhw)

*/

void Watchdog::kick(float s) { //set the watchdog duration = s seconds
	LPC_WDT->WDCLKSEL = 0x1;                // Set CLK src to PCLK
	uint32_t clk = SystemCoreClock / 16;    // WD has a fixed /4 prescaler, PCLK default is /4
	LPC_WDT->WDTC = s * (float)clk;
	LPC_WDT->WDMOD = 0x3;                   // Enabled and Reset
	kick();
}
void Watchdog::kick() { //reset the watchdog
	LPC_WDT->WDFEED = 0xAA;
	LPC_WDT->WDFEED = 0x55;
}
void Watchdog::setBU(char x) { //here only one char is transfered
	//available :5 general purpose registers 4bytes each
	LPC_RTC->GPREG0 = x;
}
char Watchdog::getBU() {
	return LPC_RTC->GPREG0;
}

/* there are status register bits for the cause of reset: power-on, watchdog timeout, etc.
  RSID voir 3.4.1 user manual Reset Source Identification Register
  LPC_SC->RSID
*/
char Watchdog::getRSID() {//returns the code for rc.startup
	uint32_t RSID = LPC_SC->RSID ;
	LPC_SC->RSID = 0x00;
	if ((RSID&0x04) ==0)  {//bit 2 =1: reset from a watchdog
		return COLDSTART ;
	} else {
		return WARMSTART; //other
	}
}